#define _WIN32_WINNT 0x0400
#define WINVER 0x0400

#include <windows.h>
#include "gen.h"
#include "frontend.h"

LRESULT WINAPI LowLevelKeyboardProc(int nCode, WPARAM wParam, LPARAM lParam);
int init();
void config();
void quit();

winampGeneralPurposePlugin _plugin = { GPPHDR_VER, "Dell Inspiron 8500, 8600 media buttons support", init, config, quit, 0, 0 };
HHOOK _keyhook = NULL;

extern "C" __declspec( dllexport ) winampGeneralPurposePlugin * winampGetGeneralPurposePlugin()
{
	return &_plugin;
}

extern "C" BOOL WINAPI _DllMainCRTStartup(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpReserved)
{
	if (fdwReason == DLL_PROCESS_ATTACH) {
		DisableThreadLibraryCalls(hinstDLL);
	}
	return TRUE;
}

LRESULT WINAPI LowLevelKeyboardProc(int nCode, WPARAM wParam, LPARAM lParam)
{
  	if (nCode == HC_ACTION) {
		if ((wParam == WM_KEYDOWN) && (((KBDLLHOOKSTRUCT *)lParam)->flags & LLKHF_EXTENDED)) {
			switch (((KBDLLHOOKSTRUCT *)lParam)->scanCode) {
			case 0x22: // play/pause button
				if (SendMessage(_plugin.hwndParent, WM_WA_IPC, 0, IPC_ISPLAYING) == 1) {
					PostMessage(_plugin.hwndParent, WM_COMMAND, WINAMP_BUTTON3, 0);
				}
				else {
					PostMessage(_plugin.hwndParent, WM_COMMAND, WINAMP_BUTTON2, 0);
				}
				return 1;
			case 0x24: // stop button
				PostMessage(_plugin.hwndParent, WM_COMMAND, WINAMP_BUTTON4, 0);
				return 1;
			case 0x10: // previous track button
				PostMessage(_plugin.hwndParent, WM_COMMAND, WINAMP_BUTTON1, 0);
				return 1;
			case 0x19: // next track button
				PostMessage(_plugin.hwndParent, WM_COMMAND, WINAMP_BUTTON5, 0);
				return 1;
			}
		}
	}
	return CallNextHookEx(_keyhook, nCode, wParam, lParam);
}

int init()
{
	_keyhook = SetWindowsHookEx(WH_KEYBOARD_LL, (HOOKPROC)LowLevelKeyboardProc, _plugin.hDllInstance, 0);
	return 0;
}

void config()
{
}

void quit()
{
	UnhookWindowsHookEx(_keyhook), _keyhook = NULL;
}
